=== added directory 'salesforce'
=== added file 'salesforce/__init__.py'
--- salesforce/__init__.py	1970-01-01 00:00:00 +0000
+++ salesforce/__init__.py	2009-12-01 11:49:48 +0000
@@ -0,0 +1,21 @@
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Sharoon Thomas.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+import salesforce_osv
+import salesforce_core
\ No newline at end of file

=== added file 'salesforce/__terp__.py'
--- salesforce/__terp__.py	1970-01-01 00:00:00 +0000
+++ salesforce/__terp__.py	2009-12-01 11:49:48 +0000
@@ -0,0 +1,37 @@
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Sharoon Thomas
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+
+{
+    "name" : "Sales force integration",
+    "author" : "Sharoon Thomas",
+    "version" : "0.1",
+    "category" : "Integration",
+    "depends" : ["base","base_contact","base_external_referentials"],
+    "demo_xml" : [],
+    "update_xml" : [
+            'settings/external.referential.type.csv',
+            'settings/external.mapping.template.csv',
+            'settings/external.mappinglines.template.csv',
+            'salesforce_core_view.xml'
+                    ],
+    "active": False,
+    "installable": True
+}
+

=== added file 'salesforce/salesforce_core.py'
--- salesforce/salesforce_core.py	1970-01-01 00:00:00 +0000
+++ salesforce/salesforce_core.py	2009-12-01 11:49:48 +0000
@@ -0,0 +1,90 @@
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Sharoon Thomas.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+from osv import osv,fields
+from tools.translate import _
+import salesforce_osv
+#If debug is true everything is logged
+DEBUG = True
+TIMEOUT = 2
+
+#class res_partner(osv.osv):
+#    _inherit="res.partner"
+#    _columns = {
+#        'salesforce_id':fields.char('Salesforce Reference',size=100),
+#        'salesforce_partner':fields.boolean('Sales Force Partner?',readonly=True,store=True)
+#                }
+#res_partner()
+
+class res_partner(salesforce_osv.salesforce_osv):
+    _name="res.partner"
+    _inherit="res.partner"
+    _columns = {
+        'salesforce_id':fields.char('Salesforce Reference',size=100),
+        'salesforce_partner':fields.boolean('Sales Force Partner?',readonly=True,store=True)
+        }
+res_partner()
+
+#class res_partner_contact(osv.osv):
+#    _inherit = "res.partner.contact"
+#    _columns = {
+#        'salesforce_id':fields.char('Salesforce Reference',size=100)
+#                }
+#res_partner_contact()
+
+class res_partner_contact(salesforce_osv.salesforce_osv):
+    _name="res.partner.contact"
+    _inherit = "res.partner.contact"
+    _columns = {
+        'salesforce_id':fields.char('Salesforce Reference',size=100)
+                }   
+res_partner_contact()
+
+class salesforce_inttools(osv.osv_memory):
+    _name="salesforce.inttools"
+    _description = "Tools to operate the tool"
+    _columns = {
+        'referential':fields.many2one('external.referential','Select Account',required=True)
+                }
+    def import_partners(self,cr,uid,ids,context={}):
+        if ids:
+            ref_id = self.read(cr,uid,ids,[])
+            if ref_id:
+                referential = self.pool.get('external.referential').browse(cr,uid,ref_id[0]['id'])
+                conn = self.pool.get('salesforce_osv').external_connection(cr,uid,referential)
+                self.pool.get('res.partner').sync_import(cr,uid,conn,ids[0],defaults={'salesforce_partner':True}, context={})
+    
+    def import_partner_contacts(self,cr,uid,ids,context={}):
+        if ids:
+            ref_id = self.read(cr,uid,ids,[])
+            if ref_id:
+                referential = self.pool.get('external.referential').browse(cr,uid,ref_id[0]['id'])
+                conn = self.pool.get('salesforce_osv').external_connection(cr,uid,referential)
+                self.pool.get('res.partner.contact').sync_import(cr,uid,conn,ids[0],defaults={}, context={})
+
+salesforce_inttools()
+
+class external_referential(salesforce_osv.salesforce_osv):
+    _inherit = "external.referential"
+    _columns = {
+        'timestamp_last':fields.char('Last time stamp',size=100)
+                }
+    
+            
+external_referential()
\ No newline at end of file

=== added file 'salesforce/salesforce_core_view.xml'
--- salesforce/salesforce_core_view.xml	1970-01-01 00:00:00 +0000
+++ salesforce/salesforce_core_view.xml	2009-12-01 11:49:48 +0000
@@ -0,0 +1,64 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<openerp>
+	<data>
+		<record model="ir.ui.view" id="salesforce_tools_form">
+			<field name="name">Sales force tools</field>
+			<field name="model">salesforce.inttools</field>
+			<field name="type">form</field>
+			<field name="arch" type="xml">
+				<form string="Tools">
+					<field name="referential" />
+					<button name="import_partners" string="1-Import Accounts (Partners)"
+						type="object" />
+					<button name="import_partner_contacts" string="2-Import Contacts (Partner Contacts)"
+						type="object" />
+				</form>
+			</field>
+		</record>
+		<record model="ir.ui.view" id="salesforce_tools_tree">
+			<field name="name">Sales force tools</field>
+			<field name="model">salesforce.inttools</field>
+			<field name="type">tree</field>
+			<field name="arch" type="xml">
+				<tree string="Tools">
+					<field name="referential" />
+				</tree>
+			</field>
+		</record>
+		<record id="ir_actions_act_window_tools" model="ir.actions.act_window">
+			<field eval="&quot;&quot;&quot;form&quot;&quot;&quot;" name="view_type" />
+			<field eval="&quot;&quot;&quot;salesforce.inttools&quot;&quot;&quot;"
+				name="res_model" />
+			<field eval="&quot;&quot;&quot;form&quot;&quot;&quot;" name="view_mode" />
+			<field eval="&quot;&quot;&quot;current&quot;&quot;&quot;" name="target" />
+			<field eval="&quot;&quot;&quot;Sales force tools&quot;&quot;&quot;"
+				name="name" />
+			<field eval="80" name="limit" />
+			<field eval="&quot;&quot;&quot;{}&quot;&quot;&quot;" name="context" />
+			<field eval="&quot;&quot;&quot;ir.actions.act_window&quot;&quot;&quot;"
+				name="type" />
+		</record>
+		<record id="ir_actions_act_window_externalreferential0" model="ir.actions.act_window">
+			<field eval="&quot;&quot;&quot;form&quot;&quot;&quot;" name="view_type" />
+			<field eval="&quot;&quot;&quot;external.referential&quot;&quot;&quot;"
+				name="res_model" />
+			<field eval="&quot;&quot;&quot;tree,form&quot;&quot;&quot;"
+				name="view_mode" />
+			<field eval="&quot;&quot;&quot;current&quot;&quot;&quot;" name="target" />
+			<field
+				eval="&quot;&quot;&quot;Sales force configuration&quot;&quot;&quot;"
+				name="name" />
+			<field eval="80" name="limit" />
+			<field eval="&quot;&quot;&quot;{}&quot;&quot;&quot;" name="context" />
+			<field eval="&quot;&quot;&quot;ir.actions.act_window&quot;&quot;&quot;"
+				name="type" />
+		</record>
+		<menuitem id="menu_salesforce" name="Sales Force Integration" />
+		<menuitem id="menu_salesforce_config" name="Sales Force Configuration"
+			parent="menu_salesforce" action="ir_actions_act_window_externalreferential0"
+			sequence="1" />
+		<menuitem id="menu_salesforce_tools" name="Sales Force Tools"
+			parent="menu_salesforce" action="ir_actions_act_window_tools"
+			sequence="2" />
+	</data>
+</openerp>
\ No newline at end of file

=== added file 'salesforce/salesforce_osv.py'
--- salesforce/salesforce_osv.py	1970-01-01 00:00:00 +0000
+++ salesforce/salesforce_osv.py	2009-12-01 11:49:48 +0000
@@ -0,0 +1,103 @@
+##############################################################################
+#    
+#    OpenERP, Open Source Management Solution
+#    Copyright (C) 2004-2009 Sharoon Thomas.
+#
+#    This program is free software: you can redistribute it and/or modify
+#    it under the terms of the GNU Affero General Public License as
+#    published by the Free Software Foundation, either version 3 of the
+#    License, or (at your option) any later version.
+#
+#    This program is distributed in the hope that it will be useful,
+#    but WITHOUT ANY WARRANTY; without even the implied warranty of
+#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#    GNU Affero General Public License for more details.
+#
+#    You should have received a copy of the GNU Affero General Public License
+#    along with this program.  If not, see <http://www.gnu.org/licenses/>.     
+#
+##############################################################################
+from osv import osv,fields
+from tools.translate import _
+import netsvc
+#Check if pyax exists and import it
+try:
+    from pyax.connection import Connection
+except:
+    raise osv.except_osv(_('Error!'), _('The pyax module is not installed\nRefer to documentation.'))
+from base_external_referentials import external_osv
+#If debug is true everything is logged
+DEBUG = True
+TIMEOUT = 2
+class Connection_wrapper(object):
+    def __init__(self, username='', password='', debug=False):
+        self.username = username
+        self.password = password
+        self.debug = debug
+        self.result = {}
+        self.logger = netsvc.Logger()
+        try:
+            self.sfdc = Connection.connect(self.username,self.password)
+        except:
+            self.sfdc = False
+    
+    def connect_check(self):
+        try:
+            timestamp = self.sfdc.getServerTimestamp()
+            self.logger.notifyChannel('SalesForce', netsvc.LOG_INFO, 'Connected to server successfully. Server Timestamp : %s' % (timestamp,))
+            return True
+        except:
+            try:
+                self.sfdc = Connection.connect(self.username,self.password)
+            except:
+                self.logger.notifyChannel('SalesForce', netsvc.LOG_WARNING, 'Could not connect to the server')
+                return False
+            return True
+
+    def call(self,query_text,arguments):
+        result=False
+        qry =  query_text
+        if arguments:
+            qry += " where "
+        for each_tuple in arguments:
+            qry += each_tuple[0] + " " + each_tuple[1] + " " + each_tuple[2] 
+        if DEBUG:
+            self.logger.notifyChannel('SalesForce', netsvc.LOG_INFO, 'New Query Generated : %s' % (qry,))
+        if self.connect_check():
+            result = self.sfdc.query(qry)
+            if DEBUG:
+                self.logger.notifyChannel('SalesForce', netsvc.LOG_INFO, 'Data for Query fetched : %s' % (result,))
+        print type(result)
+        return result
+Connection_wrapper()
+
+class salesforce_osv(external_osv.external_osv):
+    _name = "salesforce_osv"
+    def external_connection(self, cr, uid,referential):
+        conn_wrap = Connection_wrapper(referential.apiusername, referential.apipass)
+        return conn_wrap or False
+    
+    def sync_import(self,cr,uid,conn,external_referential_id,defaults={}, context={}):
+        if not 'ids_or_filter' in context.keys():
+            context['ids_or_filter'] = []
+        result = {'create_ids': [], 'write_ids': []}
+        mapping_id = self.pool.get('external.mapping').search(cr,uid,[('model','=',self._name),('referential_id','=',external_referential_id)])
+        if mapping_id:
+            data = []
+            list_method = self.pool.get('external.mapping').read(cr,uid,mapping_id[0],['external_list_method']).get('external_list_method',False)
+            if list_method:
+                data = conn.call(list_method, context['ids_or_filter'])
+                #it may happen that list method doesn't provide enough information, forcing us to use get_method on each record (case for sale orders)
+                if context.get('one_by_one', False):
+                    for record in data:
+                        id = record[self.pool.get('external.mapping').read(cr, uid, mapping_id[0],['external_key_name'])['external_key_name']]
+                        get_method = self.pool.get('external.mapping').read(cr,uid,mapping_id[0],['external_get_method']).get('external_get_method',False)
+                        rec_data = [conn.call(get_method, [id])]
+                        rec_result = self.ext_import(cr, uid, rec_data, external_referential_id, defaults, context)
+                        result['create_ids'].append(rec_result['create_ids'])
+                        result['write_ids'].append(rec_result['write_ids'])
+                else:
+                    result = self.ext_import(cr, uid, data, external_referential_id, defaults, context)
+        return result or False
+
+salesforce_osv()
\ No newline at end of file

=== added directory 'salesforce/settings'
=== added file 'salesforce/settings/external.mapping.template.csv'
--- salesforce/settings/external.mapping.template.csv	1970-01-01 00:00:00 +0000
+++ salesforce/settings/external.mapping.template.csv	2009-12-01 11:49:48 +0000
@@ -0,0 +1,4 @@
+"id","type_id:id","model_id:id","external_list_method","external_get_method","external_update_method","external_create_method","external_delete_method","external_key_name"
+"salesforce_partners","salesforce","base.model_res_partner","select Id,Name from Account",,,,,"salesforce_id"
+"salesforce_partner_address","salesforce","base.model_res_partner_address",,,,,,"salesforce_id"
+"salesforce_partner_contact","salesforce","base_contact.model_res_partner_contact","select Id,AccountId,FirstName,LastName,MobilePhone,Email from Contact",,,,,"salesforce_id"

=== added file 'salesforce/settings/external.mappinglines.template.csv'
--- salesforce/settings/external.mappinglines.template.csv	1970-01-01 00:00:00 +0000
+++ salesforce/settings/external.mappinglines.template.csv	2009-12-01 11:49:48 +0000
@@ -0,0 +1,9 @@
+"id","type_id:id","model_id:id","external_field","type","external_type","in_function","out_function"
+"sf_partner_1","salesforce","base.model_res_partner","Name","in","str","result=[('name',ifield)]",
+"sf_partner_2","salesforce","base.model_res_partner","Id","in","str","result=[('salesforce_id',ifield)]",
+"sf_partner_3","salesforce","base_contact.model_res_partner_contact","FirstName","in","str","result=[('first_name',ifield)]",
+"sf_partner_4","salesforce","base_contact.model_res_partner_contact","LastName","in","str","result=[('name',ifield)]",
+"sf_partner_5","salesforce","base_contact.model_res_partner_contact","MobilePhone","in","str","result=[('mobile',ifield)]",
+"sf_partner_6","salesforce","base_contact.model_res_partner_contact","Email","in","str","result=[('email',ifield)]",
+"sf_partner_7","salesforce","base_contact.model_res_partner_contact","Id","in","str","result=[('salesforce_id',ifield)]",
+"sf_partner_8","salesforce","base_contact.model_res_partner_contact","AccountId","in","str","result=[('partner_id',self.pool.get('res.partner').extid_to_oeid(cr, uid, ifield, external_referential_id))]",

=== added file 'salesforce/settings/external.referential.type.csv'
--- salesforce/settings/external.referential.type.csv	1970-01-01 00:00:00 +0000
+++ salesforce/settings/external.referential.type.csv	2009-12-01 11:49:48 +0000
@@ -0,0 +1,2 @@
+"id","name"
+"salesforce","Sales Force Integration"

